1. 程式人生 > >Codeforces Round #516(Div 2)

Codeforces Round #516(Div 2)

比賽連結:傳送門

A. Make a triangle!

題目大意:

給你三條邊,問你最多加多少長度能使這三條邊能構成三角形。

思路:

最大邊小於答案加另外兩條邊的和。

#include <bits/stdc++.h>

using namespace std;

int main()
{
    int a, b, c;
    cin >> a >> b >> c;
    int _max = max(a, b);
    _max = max(_max, c);
    int sum = a+b+c - _max;
    
int ans = max(0, _max-sum+1); cout << ans << endl; return 0; }
View Code

 

B. Equations of Mathematical Magic

題目大意:

給定a,求方程:a = x + (a^x)的非負整數解的數量。(符號"^"表示異或)

思路:

只有一個二進位制位時:(表示式各位置的對應未知數與上面方程對齊)

① a = 0:0 = 0 + (0^0)

② a = 1:1 = 0 + (1^0) = 1 + (1^1)

所以對於題目a的每個二進位制位:

① 如果為0,則x的對應二進位制位也只能為0

② 如果為1,則x的對應二進位制位可以是1或0

組合後答案為2k,(其中k為a變成二進位制後1的個數)

#include <bits/stdc++.h>

using namespace std;

int main()
{
    int T;
    cin >> T;
    while (T--) {
        int N;
        cin >> N;
        int cnt = 0;
        while (N) {
            if (N&1)
                cnt
++; N/=2; } cout << (1 << cnt) << endl; } return 0; } /* 3 0 2 1073741823 */
View Code

 

C. Oh Those Palindromes

題目大意:

求給定字串重排序後,最多的迴文子串數量。

思路:

把一樣的字母放在一起貌似就可以了。(直接sort)

#include <bits/stdc++.h>

using namespace std;

int cnt[30];

int main()
{
    int N;
    string s;
    cin >> N >> s;
    memset(cnt, 0, sizeof cnt);
    for (int i = 0; i < N; i++) {
        int ind = s[i] - 'a';
        cnt[ind]++;
    }
    for (int i = 0; i < 26; i++) {
        while (cnt[i]--) {
            printf("%c", 'a'+i);
        }
    }
    printf("\n");
    return 0;
}
View Code

 

D. Labyrinth

題目大意:

給定bfs圖,起始點,最多的左移次數X、右移次數Y,求能訪問的最多的格子數。

思路:

用bfs乍一搜可以pretest passed,但是可以被這組樣例hack。

/*
20 7
3 6
5 2
......*
.****.*
.****.*
....*.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**.**.*
**....*
*******
*/
View Code

加一個對當前點X、Y的最大值的維護即可。

#include <bits/stdc++.h>

using namespace std;
const int MAX_N = 2e3 + 5;
const int actx[4] = {0, 0, 1, -1};
const int acty[4] = {1, -1, 0, 0};

struct Node{
    int x, y;
    int resl, resr;
    Node(int xx = 0, int yy = 0, int ll = 0, int rr = 0) : x(xx), y(yy), resl(ll), resr(rr) {}
}nodes[MAX_N][MAX_N];

int N, M, R, C, X, Y;
char mat[MAX_N][MAX_N];
bool vis[MAX_N][MAX_N];

inline bool check(int x, int y)
{
    if (x < 1 || x > N || y < 1 || y > M)
        return false;
    if (mat[x][y] == '*')
        return false;
    return true;
}

int main()
{
    cin >> N >> M >> R >> C >> X >> Y;
    memset(vis, false, sizeof vis);
    for (int i = 1; i <= N; i++)
        scanf("%s", mat[i]+1);

    queue <Node> Q;
    vis[R][C] = true;
    Q.push(Node(R, C, X, Y));
    while (!Q.empty()) {
        Node cur = Q.front(); Q.pop();
        for (int i = 0; i < 4; i++) {
            int x = cur.x + actx[i];
            int y = cur.y + acty[i];
            if (!check(x, y))
                continue;
            int l = cur.resl;
            int r = cur.resr;
            if (i == 0)
                r--;
            if (i == 1)
                l--;
            if (l < 0 || r < 0)
                continue;
            if (x == 4 && y == 4)
                int aaa = 1;
            if (vis[x][y]) {
                if (l > nodes[x][y].resl || r > nodes[x][y].resr) {
                    nodes[x][y].resl = max(l, nodes[x][y].resl);
                    nodes[x][y].resr = max(r, nodes[x][y].resr);
                }
                else
                    continue;
            }
            else if (!vis[x][y]) {
                nodes[x][y] = Node(x, y, l, r);
                vis[x][y] = true;
            }
            Q.push(Node(x, y, l, r));
        }
    }
    int ans = 0;
    for (int i = 1; i <= N; i++) {
        for (int j = 1; j <= M; j++) {
            if (vis[i][j])
                ans++;
        }
    }
    cout << ans << endl;
    return 0;
}
View Code

 

E. Dwarves, Hats and Extrasensory Abilities

題目大意:

互動式的題目,給定N,然後你輸出N個點的座標,你每輸出一個點,他給你這個點的顏色(隨機黑或白),然後讓你給出一條直線,使得黑白的點線上的兩邊。

思路:

二分座標系。注意題目中座標系的上限直接拿來用的話,不夠N的最大值。

#include <iostream>

using namespace std;

int main()
{
    int N;
    cin >> N;
    int l = 0, r = 1 << 29;
    string sl, scur;
    cout << l << ' ' << l << endl << flush;
    cin >> sl;
    if (N == 1) {
        cout << 1 << ' ' << 0 << endl << flush;
        cout << 1 << ' ' << 1 << endl << flush;
        return 0;
    }
    cout << r << ' ' << 0 << endl << flush;
    cin >> scur;
    N -= 2;
    if (sl == scur) {//在(2^29, 0)到(2^29, 2^29)內二分
        int mid = (l + r) >> 1;
        int x = 1 << 29;
        while (N--) {
            cout << x << ' ' << mid << endl << flush;
            cin >> scur;
            if (scur == sl)
                l = mid;
            else
                r = mid;
            mid = (l + r) >> 1;
        }
        cout << x << ' ' << mid << endl << flush;
        cout << x-1 << ' ' << mid << endl << flush;
    }
    else {
        int mid = (l+r) >> 1;
        int y = 0;
        while (N--) {
            cout << mid << ' ' << y << endl << flush;
            cin >> scur;
            if (sl == scur) {
                l = mid;
            }
            else {
                r = mid;
            }
            mid = (l+r) >> 1;
        }
        cout << mid << ' ' << y << endl << flush;
        cout << mid << ' ' << y+1 << endl << flush;
    }
    return 0;
}
View Code

 

F. Candies for Children

題目大意:

有n個人圍成一圈分k個糖果,從 l 開始分到 r ,可以跑很多圈。一個人拿一顆,裡面有p個人喜歡甜食會拿兩顆。

問你p的最大值。資料矛盾則輸出-1。

思路:

題目中的資料範圍是1e11,這個資料很微妙(1e11 = 1e5 * 1e6),所以分兩種情況討論:

① n < 2e6 :

   這時候可以直接跑答案

② n > 2e6 :

   這時候跑圈數i,每個對應的圈數可以求出最大的喜歡甜食的人數:

  1、(p + n) * i + y + d = k

  2、p - y <= n - d

  聯立這個就可以求p的最大值,然後處理一下細節就可以O(1)複雜度跑一個i。(其中d表示l跑到r的人數,y表示d中的喜甜人數)

然後暴力跑就好了。注意一個點就是最後一個人可以喜歡甜食但是隻拿一個。

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll X = 2e6 + 5;

int main()
{
    ll n, l, r, k;
    cin >> n >> l >> r >> k;
    ll d = (r - l + n) % n + 1;

    ll ans = -1;
    if (n < X) {
        for (ll p = n; p >= 0; p--) {
            ll y = (k - 1)%(n + p) + 1 - d;
            if (y < 0 || y > p || y > d || d-(y+1) > n-p)
                continue;
            ll y2 = y+1;
            if (y2 <= p && y2 <= d) {
                ans = max(ans , p);
            }
            if (d-y <= n-p) {
                ans = max(ans, p);
            }
        }
    }
    else {
        for (ll i = 0; i <= k/n; i++) {
            ll p = (k - 2*d - (i-1)*n + 1) / (i+1);
            ll y = k - i*(n+p) - d;
            if (y < 0) {
                if (i == 0)
                    continue;
                ll dis = (-y - 1) / i + 1;
                y += i*dis;
                p -= dis;
            }
            if (p > n) {
                y += (p-n) * i;
                p == n;
            }
            if (y < 0 || y > p || y > d || d-(y+1) > n-p)
                continue;
            ll y2 = y+1;
            if (y2 <= p && y2 <= d) {
                ans = max(ans , p);
            }
            if (d-y <= n-p) {
                ans = max(ans, p);
            }
        }
    }
    cout << ans << endl;
    return 0;
}
/*
10 5 5 1
10000000 5 5 1
*/
View Code